Index: LMDZ4/trunk/libf/phylmd/limit_read_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/limit_read_mod.F90	(revision 996)
+++ LMDZ4/trunk/libf/phylmd/limit_read_mod.F90	(revision 996)
@@ -0,0 +1,331 @@
+!
+! $Header$
+!
+MODULE limit_read_mod
+!
+! This module reads the fichier "limit.nc" containing fields for surface forcing.
+!
+! Module subroutines :
+!  limit_read_frac    : call limit_read_tot and return the fractions
+!  limit_read_rug_alb : return rugosity and albedo, if coupled ocean call limit_read_tot first
+!  limit_read_sst     : return sea ice temperature   
+!  limit_read_tot     : read limit.nc and store the fields in local modules variables
+!
+  IMPLICIT NONE
+
+  REAL, ALLOCATABLE, DIMENSION(:,:), SAVE, PRIVATE :: pctsrf
+  REAL, ALLOCATABLE, DIMENSION(:),   SAVE, PRIVATE :: rugos
+  REAL, ALLOCATABLE, DIMENSION(:),   SAVE, PRIVATE :: albedo
+  REAL, ALLOCATABLE, DIMENSION(:),   SAVE, PRIVATE :: sst
+  LOGICAL :: read_continents=.FALSE.
+
+CONTAINS
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!
+!! Public subroutines :
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  SUBROUTINE limit_read_frac(itime, dtime, jour, pctsrf_new, is_modified)
+!
+! This subroutine is called from "change_srf_frac" for case of 
+! ocean=force or from ocean_slab_frac for ocean=slab.
+! The fraction for all sub-surfaces at actual time step is returned.
+
+    USE dimphy
+    INCLUDE "indicesol.h"
+
+! Input arguments
+!****************************************************************************************
+    INTEGER, INTENT(IN) :: itime   ! time step
+    INTEGER, INTENT(IN) :: jour    ! current day
+    REAL   , INTENT(IN) :: dtime   ! length of time step
+  
+! Output arguments
+!****************************************************************************************
+    REAL, DIMENSION(klon,nbsrf), INTENT(OUT) :: pctsrf_new  ! sub surface fractions
+    LOGICAL, INTENT(OUT)                     :: is_modified ! true if pctsrf is modified at this time step
+
+! End declaration
+!****************************************************************************************
+
+! 1) Read file limit.nc
+    CALL limit_read_tot(itime, dtime, jour, is_modified)
+
+! 2) Return the fraction read in limit_read_tot
+    pctsrf_new(:,:) = pctsrf(:,:)
+    
+  END SUBROUTINE limit_read_frac
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  SUBROUTINE limit_read_rug_alb(itime, dtime, jour, &
+       knon, knindex, &
+       rugos_out, alb_out)
+!
+! This subroutine is called from surf_land_bucket. 
+! The flag "ok_veget" must can not be true. If coupled run, "ocean=couple"
+! then this routine will call limit_read_tot.
+!
+    USE dimphy
+    USE surface_data
+
+! Input arguments
+!****************************************************************************************
+    INTEGER, INTENT(IN) :: itime                     ! numero du pas de temps courant
+    INTEGER, INTENT(IN) :: jour                      ! jour a lire dans l'annee
+    REAL   , INTENT(IN) :: dtime                     ! pas de temps de la physique (en s)
+    INTEGER, INTENT(IN) :: knon                      ! nomber of points on compressed grid
+    INTEGER, DIMENSION(klon), INTENT(IN) :: knindex  ! grid point number for compressed grid
+! Output arguments
+!****************************************************************************************
+    REAL, DIMENSION(klon), INTENT(OUT) :: rugos_out
+    REAL, DIMENSION(klon), INTENT(OUT) :: alb_out
+    
+! Local variables
+!****************************************************************************************
+    INTEGER :: i
+    LOGICAL :: is_modified
+!****************************************************************************************
+
+    IF (type_ocean == 'couple') THEN
+       ! limit.nc has not yet been read. Do it now!
+       CALL limit_read_tot(itime, dtime, jour, is_modified)
+    END IF
+
+    DO i=1,knon
+       rugos_out(i) = rugos(knindex(i))
+       alb_out(i)  = albedo(knindex(i))
+    END DO
+
+  END SUBROUTINE limit_read_rug_alb
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  SUBROUTINE limit_read_sst(knon, knindex, sst_out)
+!
+! This subroutine returns the sea surface temperature already read from limit.nc.
+!
+    USE dimphy, ONLY : klon
+
+    INTEGER, INTENT(IN)                  :: knon     ! nomber of points on compressed grid
+    INTEGER, DIMENSION(klon), INTENT(IN) :: knindex  ! grid point number for compressed grid
+    REAL, DIMENSION(klon), INTENT(OUT)   :: sst_out
+
+    INTEGER :: i
+
+    DO i = 1, knon
+       sst_out(i) = sst(knindex(i))
+    END DO
+
+  END SUBROUTINE limit_read_sst
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!
+!! Private subroutine :
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  SUBROUTINE limit_read_tot(itime, dtime, jour, is_modified)
+!
+! Read everything needed from limit.nc
+!
+! 0) Initialize
+! 1) Open the file limit.nc, if it is time
+! 2) Read fraction, if not type_ocean=couple
+! 3) Read sea surface temperature, if not type_ocean=couple
+! 4) Read albedo and rugosity for land surface, only in case of no vegetation model
+! 5) Close file and distribuate variables to all processus
+
+    USE dimphy
+    USE mod_grid_phy_lmdz
+    USE mod_phys_lmdz_para
+    USE surface_data, ONLY : type_ocean, ok_veget
+    USE netcdf
+
+    IMPLICIT NONE
+    
+    INCLUDE "indicesol.h"
+
+! In- and ouput arguments
+!****************************************************************************************
+    INTEGER, INTENT(IN) :: itime   ! numero du pas de temps courant
+    INTEGER, INTENT(IN) :: jour    ! jour a lire dans l'annee
+    REAL   , INTENT(IN) :: dtime   ! pas de temps de la physique (en s)
+
+    LOGICAL, INTENT(OUT) :: is_modified  ! true if pctsrf is modified at this time step
+
+! Locals variables with attribute SAVE
+!****************************************************************************************
+! frequence de lecture des conditions limites (en pas de physique) 
+    INTEGER,SAVE                              :: lmt_pas   
+    LOGICAL, SAVE                             :: first_call=.TRUE.
+    
+! Locals variables
+!****************************************************************************************
+    INTEGER                                   :: nid, nvarid
+    INTEGER                                   :: ii, ierr
+    INTEGER, DIMENSION(2)                     :: start, epais
+    REAL, DIMENSION(klon_glo,nbsrf)           :: pct_glo  ! fraction at global grid
+    REAL, DIMENSION(klon_glo)                 :: sst_glo  ! sea-surface temperature at global grid
+    REAL, DIMENSION(klon_glo)                 :: rug_glo  ! rugosity at global grid
+    REAL, DIMENSION(klon_glo)                 :: alb_glo  ! albedo at global grid
+    CHARACTER(len=20)                         :: modname='limit_read_mod'     
+
+! End declaration
+!****************************************************************************************
+
+!****************************************************************************************
+! 0) Initialization
+!
+!****************************************************************************************
+    IF (first_call) THEN
+       ! calculate number of time steps for one day
+       lmt_pas = NINT(86400./dtime * 1.0)
+       
+       ! Allocate module save variables
+       IF ( type_ocean /= 'couple' ) THEN
+          ALLOCATE(pctsrf(klon,nbsrf), sst(klon), stat=ierr)
+          IF (ierr /= 0) CALL abort_gcm(modname, 'PB in allocating pctsrf and sst',1)
+       END IF
+
+       IF ( .NOT. ok_veget ) THEN
+          ALLOCATE(rugos(klon), albedo(klon), stat=ierr)
+          IF (ierr /= 0) CALL abort_gcm(modname, 'PB in allocating rugos and albedo',1)
+       END IF
+
+       first_call=.FALSE.
+    ENDIF
+  
+!****************************************************************************************
+! 1) Open the file limit.nc if it is the right moment to read, once a day.
+!    The file is read only by the master thread of the master mpi process(is_mpi_root)
+!
+!****************************************************************************************
+
+    is_modified = .FALSE.
+    IF (MOD(itime-1, lmt_pas) == 0) THEN   ! time to read
+       is_modified = .TRUE.
+!$OMP MASTER  ! Only master thread
+       IF (is_mpi_root) THEN ! Only master processus
+
+          ierr = NF90_OPEN ('limit.nc', NF90_NOWRITE, nid)
+          IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,&
+               'Pb d''ouverture du fichier de conditions aux limites',1)
+          
+          ! La tranche de donnees a lire:
+          start(1) = 1
+          start(2) = jour
+          epais(1) = klon_glo
+          epais(2) = 1
+
+
+!****************************************************************************************
+! 2) Read fraction if not type_ocean=couple
+!
+!****************************************************************************************
+
+          IF ( type_ocean /= 'couple') THEN
+!
+! Ocean fraction
+             ierr = NF90_INQ_VARID(nid, 'FOCE', nvarid)
+             IF (ierr /= NF90_NOERR) CALL abort_gcm(modname, 'Le champ <FOCE> est absent',1)
+             
+             ierr = NF90_GET_VAR(nid,nvarid,pct_glo(:,is_oce),start,epais)
+             IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Lecture echouee pour <FOCE>' ,1)
+!
+! Sea-ice fraction
+             ierr = NF90_INQ_VARID(nid, 'FSIC', nvarid)
+             IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Le champ <FSIC> est absent',1)
+
+             ierr = NF90_GET_VAR(nid,nvarid,pct_glo(:,is_sic),start,epais)
+             IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Lecture echouee pour <FSIC>' ,1)
+
+
+! Read land and continentals fraction only if asked for
+             IF (read_continents .OR. itime == 1) THEN
+!
+! Land fraction
+                ierr = NF90_INQ_VARID(nid, 'FTER', nvarid)
+                IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Le champ <FTER> est absent',1)
+                
+                ierr = NF90_GET_VAR(nid,nvarid,pct_glo(:,is_ter),start,epais)
+                IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Lecture echouee pour <FTER>',1)
+!
+! Continentale ice fraction
+                ierr = NF90_INQ_VARID(nid, 'FLIC', nvarid)
+                IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Le champ <FLIC> est absent',1)
+
+                ierr = NF90_GET_VAR(nid,nvarid,pct_glo(:,is_lic),start,epais)
+                IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Lecture echouee pour <FLIC>',1)
+             END IF
+
+          END IF ! type_ocean /= couple
+
+!****************************************************************************************
+! 3) Read sea-surface temperature, if not coupled ocean
+!
+!****************************************************************************************
+          IF ( type_ocean /= 'couple') THEN
+
+             ierr = NF90_INQ_VARID(nid, 'SST', nvarid)
+             IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Le champ <SST> est absent',1)
+
+             ierr = NF90_GET_VAR(nid,nvarid,sst_glo,start,epais)
+             IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Lecture echouee pour <SST>',1)
+          
+          END IF
+
+!****************************************************************************************
+! 4) Read albedo and rugosity for land surface, only in case of no vegetation model
+!
+!****************************************************************************************
+
+          IF (.NOT. ok_veget) THEN
+!
+! Read albedo
+             ierr = NF90_INQ_VARID(nid, 'ALB', nvarid)
+             IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Le champ <ALB> est absent',1)
+
+             ierr = NF90_GET_VAR(nid,nvarid,alb_glo,start,epais)
+             IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Lecture echouee pour <ALB>',1)
+!
+! Read rugosity
+             ierr = NF90_INQ_VARID(nid, 'RUG', nvarid)
+             IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Le champ <RUG> est absent',1)
+
+             ierr = NF90_GET_VAR(nid,nvarid,rug_glo,start,epais)
+             IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Lecture echouee pour <RUG>',1)
+
+          END IF
+
+!****************************************************************************************
+! 5) Close file and distribuate variables to all processus
+!
+!****************************************************************************************
+          ierr = NF90_CLOSE(nid)
+          IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Pb when closing file', 1)
+       ENDIF ! is_mpi_root
+
+!$OMP END MASTER
+!$OMP BARRIER
+
+       IF ( type_ocean /= 'couple') THEN
+          CALL Scatter(sst_glo,sst)
+          CALL Scatter(pct_glo(:,is_oce),pctsrf(:,is_oce))
+          CALL Scatter(pct_glo(:,is_sic),pctsrf(:,is_sic))
+          IF (read_continents .OR. itime == 1) THEN
+             CALL Scatter(pct_glo(:,is_ter),pctsrf(:,is_ter))
+             CALL Scatter(pct_glo(:,is_lic),pctsrf(:,is_lic))
+          END IF
+       END IF
+
+       IF (.NOT. ok_veget) THEN
+          CALL Scatter(alb_glo, albedo)
+          CALL Scatter(rug_glo, rugos)
+       END IF
+
+    ENDIF ! time to read
+
+  END SUBROUTINE limit_read_tot
+
+
+END MODULE limit_read_mod
Index: LMDZ4/trunk/libf/phylmd/limit_slab.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/limit_slab.F90	(revision 996)
+++ LMDZ4/trunk/libf/phylmd/limit_slab.F90	(revision 996)
@@ -0,0 +1,121 @@
+! $Header$
+
+SUBROUTINE limit_slab(itime, dtime, jour, lmt_bils, lmt_foce, diff_sst)
+
+  USE dimphy
+  USE mod_grid_phy_lmdz
+  USE mod_phys_lmdz_para
+  USE netcdf 
+
+  IMPLICIT NONE
+
+  INCLUDE "indicesol.h"
+  INCLUDE "temps.h"
+  INCLUDE "clesphys.h"
+  INCLUDE "dimensions.h"
+
+! In- and ouput arguments
+!****************************************************************************************
+  INTEGER, INTENT(IN) :: itime   ! numero du pas de temps courant
+  INTEGER, INTENT(IN) :: jour    ! jour a lire dans l'annee
+  REAL   , INTENT(IN) :: dtime   ! pas de temps de la physique (en s)
+  REAL, DIMENSION(klon), INTENT(OUT) :: lmt_bils, lmt_foce, diff_sst
+
+! Locals variables with attribute SAVE
+!****************************************************************************************
+  REAL, DIMENSION(:), ALLOCATABLE, SAVE :: bils_save, foce_save
+
+! Locals variables
+!****************************************************************************************
+  INTEGER                  :: lmt_pas   
+  INTEGER                  :: nvarid, nid, ierr, i
+  INTEGER, DIMENSION(2)    :: start, epais 
+  REAL, DIMENSION(klon_glo):: bils_glo, foce_glo, sst_l_glo, sst_lp1_glo, diff_sst_glo
+  CHARACTER (len = 20)     :: modname = 'limit_slab'
+
+! End declaration
+!****************************************************************************************
+
+  ! calculate number of time steps for one day
+  lmt_pas = NINT(86400./dtime)
+  
+  IF (MOD(itime-1, lmt_pas) == 0) THEN   ! time to read
+     !$OMP MASTER  ! Only master thread
+     IF (is_mpi_root) THEN ! Only master processus
+        print*,'in limit_slab time to read, itime=',itime
+        
+        ierr = NF90_OPEN ('limit_slab.nc', NF90_NOWRITE, nid)
+        IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,&
+             'Pb in opening file limit_slab.nc',1)
+        
+        ! La tranche de donnees a lire:
+        start(1) = 1
+        start(2) = jour
+        epais(1) = klon_glo
+        epais(2) = 1
+
+!****************************************************************************************
+! 2) Read bils and ocean fraction
+!
+!****************************************************************************************
+!
+! Read bils_glo
+        ierr = NF90_INQ_VARID(nid, 'BILS_OCE', nvarid)
+        IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'The variable <BILS_OCE> is abstent',1)
+
+        ierr = NF90_GET_VAR(nid,nvarid,bils_glo,start,epais)
+        IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Reading of <BILS_OCE> failed',1)
+!
+! Read foce_glo
+        ierr = NF90_INQ_VARID(nid, 'FOCE', nvarid)
+        IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'The variable <FOCE> is abstent',1)
+
+        ierr = NF90_GET_VAR(nid,nvarid,foce_glo,start,epais)
+        IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Reading of <FOCE> failed',1)
+!
+! Read sst_glo for this day
+        ierr = NF90_INQ_VARID(nid, 'SST', nvarid)
+        IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'The variable <SST> is abstent',1)
+
+        ierr = NF90_GET_VAR(nid,nvarid,sst_l_glo,start,epais)
+        IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Reading of <SST> failed',1)
+
+! Read sst_glo for one day ahead
+        start(2) = jour + 1
+        IF (start(2) > 360) start(2)=1
+        ierr = NF90_GET_VAR(nid,nvarid,sst_lp1_glo,start,epais)
+        IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Reading of <SST> day+1 failed',1)
+
+! Calculate difference in temperature between this day and one ahead
+        DO i=1, klon_glo-1
+           diff_sst_glo(i) = sst_lp1_glo(i) - sst_l_glo(i)
+        END DO
+        diff_sst_glo(klon_glo) = sst_lp1_glo(klon_glo) - sst_l_glo(1)
+
+!****************************************************************************************
+! 5) Close file and distribuate variables to all processus
+!
+!****************************************************************************************
+        ierr = NF90_CLOSE(nid)
+        IF (ierr /= NF90_NOERR) CALL abort_gcm(modname,'Pb when closing file', 1)
+     ENDIF ! is_mpi_root
+
+!$OMP END MASTER
+       
+     IF (.NOT. ALLOCATED(bils_save)) THEN
+        ALLOCATE(bils_save(klon), foce_save(klon), stat=ierr)
+        IF (ierr /= 0) CALL abort_gcm('limit_slab', 'pb in allocation',1)
+     END IF
+
+     CALL Scatter(bils_glo, bils_save)
+     CALL Scatter(foce_glo, foce_save)
+     CALL Scatter(diff_sst_glo, diff_sst)
+     
+  ELSE ! not time to read
+     diff_sst(:) = 0.
+  ENDIF ! time to read
+
+  lmt_bils(:) = bils_save(:)
+  lmt_foce(:) = foce_save(:)
+  
+END SUBROUTINE limit_slab
Index: LMDZ4/trunk/libf/phylmd/oasis.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/oasis.F90	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/oasis.F90	(revision 996)
@@ -44,5 +44,4 @@
   !$OMP THREADPRIVATE(out_var_id)
 
-  CHARACTER(LEN=*),PARAMETER :: OPA_version='OPA9'
 
 #ifdef CPP_COUPLE
@@ -58,4 +57,5 @@
 !     LF 09/2003
 !
+    USE surface_data, ONLY : version_ocean
     INCLUDE "dimensions.h"
 
@@ -130,14 +130,16 @@
 !     Define symbolic name for fields exchanged from atmos to coupler,
 !         must be the same as (1) of the field  definition in namcouple:
-    IF (OPA_version=='OPA9') THEN
-      cl_writ(1)='COTAUXXU'
-      cl_writ(2)='COTAUYYU'
-      cl_writ(3)='COTAUZZU'
-      cl_writ(4)='COTAUXXV'
-      cl_writ(5)='COTAUYYV'
-      cl_writ(6)='COTAUZZV'
-      cl_writ(7)='COWINDSP'
-      cl_writ(8)='COPEFWAT'
-      cl_writ(9)='COPEFICE'
+
+    cl_writ(1)='COTAUXXU'
+    cl_writ(2)='COTAUYYU'
+    cl_writ(3)='COTAUZZU'
+    cl_writ(4)='COTAUXXV'
+    cl_writ(5)='COTAUYYV'
+    cl_writ(6)='COTAUZZV'
+    cl_writ(7)='COWINDSP'
+    
+    IF (version_ocean=='nemo') THEN
+      cl_writ(8) ='COPEFWAT'
+      cl_writ(9) ='COPEFICE'
       cl_writ(10)='COTOSPSU'
       cl_writ(11)='COICEVAP'
@@ -150,14 +152,7 @@
       cl_writ(18)='CRWOCERD'
       cl_writ(19)='CRWOCECD'
-    ELSE IF (OPA_version=='OPA8') THEN
-      cl_writ(1)='COTAUXXU'
-      cl_writ(2)='COTAUYYU'
-      cl_writ(3)='COTAUZZU'
-      cl_writ(4)='COTAUXXV'
-      cl_writ(5)='COTAUYYV'
-      cl_writ(6)='COTAUZZV'
-      cl_writ(7)='COWINDSP'
-      cl_writ(8)='COSHFICE'
-      cl_writ(9)='COSHFOCE'
+    ELSE IF (version_ocean=='opa8') THEN
+      cl_writ(8) ='COSHFICE'
+      cl_writ(9) ='COSHFOCE'
       cl_writ(10)='CONSFICE'
       cl_writ(11)='CONSFOCE'
@@ -170,6 +165,4 @@
       cl_writ(18)='CORIVFLU'
       cl_writ(19)='COCALVIN'
-    ELSE
-      STOP 'Bad OPA version for coupled model'
     ENDIF
 
@@ -178,18 +171,16 @@
 !         must be the same as (2) of the field  definition in namcouple:
 !
-    IF (OPA_version=='OPA9') THEN
-      cl_read(1)='SISUTESW'
-      cl_read(2)='SIICECOV'
-      cl_read(4)='SIICEALW'
-      cl_read(3)='SIICTEMW'
-    ELSE IF (OPA_version=='OPA8') THEN
-      cl_read(1)='SISUTESW'
-      cl_read(2)='SIICECOV'
-      cl_read(3)='SIICEALW'
-      cl_read(4)='SIICTEMW'
-    ELSE
-      STOP 'Bad OPA version for coupled model'
-    ENDIF
-    
+    IF (version_ocean=='nemo') THEN
+       cl_read(1)='SISUTESW'
+       cl_read(2)='SIICECOV'
+       cl_read(4)='SIICEALW'
+       cl_read(3)='SIICTEMW'
+    ELSE IF (version_ocean=='opa8') THEN
+       cl_read(1)='SISUTESW'
+       cl_read(2)='SIICECOV'
+       cl_read(3)='SIICEALW'
+       cl_read(4)='SIICTEMW'
+    END IF
+
     il_var_nodims(1) = 2
     il_var_nodims(2) = 1
Index: LMDZ4/trunk/libf/phylmd/ocean_cpl_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/ocean_cpl_mod.F90	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/ocean_cpl_mod.F90	(revision 996)
@@ -16,10 +16,5 @@
   PRIVATE
 
-  PUBLIC :: ocean_cpl_init, ocean_cpl_get_vars, ocean_cpl_noice, ocean_cpl_ice
-
-  REAL, ALLOCATABLE, DIMENSION(:), SAVE       :: tmp_flux_o
-  !$OMP THREADPRIVATE(tmp_flux_o)
-  REAL, ALLOCATABLE, DIMENSION(:), SAVE       :: tmp_flux_g
-  !$OMP THREADPRIVATE(tmp_flux_g)
+  PUBLIC :: ocean_cpl_init, ocean_cpl_noice, ocean_cpl_ice
 
 !****************************************************************************************
@@ -43,17 +38,4 @@
     CHARACTER (len = 80) :: abort_message
     CHARACTER (len = 20) :: modname = 'ocean_cpl_init'
-
-
-    ALLOCATE(tmp_flux_o(klon), stat = error)
-    IF (error /= 0) THEN
-       abort_message='Pb allocation tmp_flux_o'
-       CALL abort_gcm(modname,abort_message,1)
-    ENDIF
-
-    ALLOCATE(tmp_flux_g(klon), stat = error)
-    IF (error /= 0) THEN
-       abort_message='Pb allocation tmp_flux_g'
-       CALL abort_gcm(modname,abort_message,1)
-    ENDIF
 
 ! Initialize module cpl_init
@@ -71,8 +53,8 @@
        p1lay, tq_cdrag, precip_rain, precip_snow, temp_air, spechum, &
        petAcoef, peqAcoef, petBcoef, peqBcoef, &
-       ps, u1_lay, v1_lay, pctsrf_in, &
+       ps, u1_lay, v1_lay, &
        radsol, snow, agesno, &
        qsurf, evap, fluxsens, fluxlat, &
-       tsurf_new, dflux_s, dflux_l, pctsrf_oce)
+       tsurf_new, dflux_s, dflux_l)
 !
 ! This subroutine treats the "open ocean", all grid points that are not entierly covered
@@ -101,5 +83,4 @@
     REAL, DIMENSION(klon), INTENT(IN)        :: ps
     REAL, DIMENSION(klon), INTENT(IN)        :: u1_lay, v1_lay
-    REAL, DIMENSION(klon,nbsrf), INTENT(IN)  :: pctsrf_in
 
 ! In/Output arguments
@@ -115,5 +96,4 @@
     REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
     REAL, DIMENSION(klon), INTENT(OUT)       :: dflux_s, dflux_l      
-    REAL, DIMENSION(klon), INTENT(OUT)       :: pctsrf_oce
 
 ! Local variables
@@ -122,5 +102,4 @@
     INTEGER, DIMENSION(1) :: iloc
     REAL, DIMENSION(klon) :: cal, beta, dif_grnd
-    REAL, DIMENSION(klon) :: zx_sl
     REAL, DIMENSION(klon) :: fder_new
     REAL, DIMENSION(klon) :: tsurf_cpl
@@ -134,10 +113,8 @@
 
 !****************************************************************************************
-! Receive sea-surface temperature(tsurf_cpl) and new fraction of ocean surface(pctsrf_oce) 
-! from coupler
-!
-!****************************************************************************************
-    CALL cpl_receive_ocean_fields(itime, dtime, knon, knindex, pctsrf_in, &
-         tsurf_cpl, pctsrf_oce)
+! Receive sea-surface temperature(tsurf_cpl) from coupler
+!
+!****************************************************************************************
+    CALL cpl_receive_ocean_fields(knon, knindex, tsurf_cpl)
 
 !****************************************************************************************
@@ -176,21 +153,4 @@
 
 !****************************************************************************************
-! Flux ocean-atmosphere useful for "slab" ocean but here calculated only for printing
-! usage later in physiq  
-! 
-!****************************************************************************************
-    tmp_flux_o(:) = 0.0
-    DO i=1, knon
-       zx_sl(i) = RLVTT
-       IF (tsurf_new(i) .LT. RTT) zx_sl(i) = RLSTT
-       !IM     flux_o(i) = fluxsens(i)-evap(i)*zx_sl(i)
-       !       flux_o(i) = fluxsens(i) + fluxlat(i)
-       IF (pctsrf_oce(knindex(i)) .GT. epsfra) THEN
-          tmp_flux_o(knindex(i)) = fluxsens(i) + fluxlat(i)
-       ENDIF
-    ENDDO
-
-
-!****************************************************************************************
 ! Send and cumulate fields to the coupler
 !
@@ -213,8 +173,8 @@
        p1lay, tq_cdrag, precip_rain, precip_snow, temp_air, spechum, &
        petAcoef, peqAcoef, petBcoef, peqBcoef, &
-       ps, u1_lay, v1_lay, pctsrf_in, &
+       ps, u1_lay, v1_lay, pctsrf, &
        radsol, snow, qsurf, &
        alb1_new, alb2_new, evap, fluxsens, fluxlat, &
-       tsurf_new, dflux_s, dflux_l, pctsrf_sic)
+       tsurf_new, dflux_s, dflux_l)
 !
 ! This subroutine treats the ocean where there is ice. The subroutine first receives 
@@ -244,5 +204,5 @@
     REAL, DIMENSION(klon), INTENT(IN)        :: ps
     REAL, DIMENSION(klon), INTENT(IN)        :: u1_lay, v1_lay
-    REAL, DIMENSION(klon,nbsrf), INTENT(IN)  :: pctsrf_in
+    REAL, DIMENSION(klon,nbsrf), INTENT(IN)  :: pctsrf
 
 ! In/output arguments
@@ -258,5 +218,4 @@
     REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
     REAL, DIMENSION(klon), INTENT(OUT)       :: dflux_s, dflux_l      
-    REAL, DIMENSION(klon), INTENT(OUT)       :: pctsrf_sic
 
 ! Local variables
@@ -277,11 +236,10 @@
 
 !****************************************************************************************
-! Receive ocean temperature(tsurf_cpl), albedo(alb_cpl) and new fraction of 
-! seaice(pctsrf_sic) from coupler
+! Receive ocean temperature(tsurf_cpl) and albedo(alb_new) from coupler
 !
 !****************************************************************************************
 
     CALL cpl_receive_seaice_fields(knon, knindex, &
-         tsurf_cpl, alb_cpl, pctsrf_sic)
+         tsurf_cpl, alb_cpl)
 
     alb1_new(1:knon) = alb_cpl(1:knon)
@@ -308,20 +266,5 @@
     CALL calcul_wind_flux(knon, dtime, taux, tauy)
     
-!****************************************************************************************
-! Flux ocean-atmosphere useful for "slab" ocean but here calculated only for printing
-! usage later in physiq  
-! 
-!  IM: faire dependre le coefficient de conduction de la glace de mer
-!      de l'epaisseur de la glace de mer, dans l'hypothese ou le coeff.
-!      actuel correspond a 3m de glace de mer, cf. L.Li
-!
-!****************************************************************************************
-    tmp_flux_g(:) = 0.0
-    DO i = 1, knon
-       IF (cal(i) .GT. 1.0e-15 .AND. pctsrf_sic(knindex(i)) .GT. epsfra) &
-            tmp_flux_g(knindex(i)) = (tsurf_new(i)-t_grnd) * &
-            dif_grnd(i) * RCPD/cal(i) 
-    ENDDO
-    
+   
 !****************************************************************************************
 ! Calculate fder : flux derivative (sensible and latente)
@@ -344,5 +287,5 @@
 
     CALL cpl_send_seaice_fields(itime, dtime, knon, knindex, &
-       pctsrf_in, lafin, rlon, rlat, &
+       pctsrf, lafin, rlon, rlat, &
        swnet, lwnet, fluxlat, fluxsens, &
        precip_rain, precip_snow, evap, tsurf_new, fder_new, alb1, taux, tauy)
@@ -353,19 +296,3 @@
 !****************************************************************************************
 !
-  SUBROUTINE ocean_cpl_get_vars(flux_o, flux_g)
-
-! This subroutine returns variables private in this module to an external 
-! routine (physiq).
-
-    REAL, DIMENSION(klon), INTENT(OUT) :: flux_o
-    REAL, DIMENSION(klon), INTENT(OUT) :: flux_g
-
-! Set the output variables
-    flux_o(:) = tmp_flux_o(:)
-    flux_g(:) = tmp_flux_g(:)
-
-  END SUBROUTINE ocean_cpl_get_vars
-!
-!****************************************************************************************
-!
 END MODULE ocean_cpl_mod
